#ifndef THREAD_HH__
#define THREAD_HH__

#include <pthread.h>

#include "Mutex.hh"


class Thread {
	pthread_t thread_id_;
	bool is_started_;
	bool joinable_;
	Mutex mutex_;

	static void* internal_run(void* arg);
public:
	Thread(bool joinable=false);
	virtual ~Thread();

	void start();
	bool is_started();

	void join();
	bool is_joinable();

	virtual void run()=0;
};

#endif
