#include "Thread.hh"
#include "Semaphore.hh"

#include <iostream>
#include <ctime>
#include <vector>

using namespace std;

class P: public Thread {
	int id_;
	Semaphore& sem_;
public:
	P(int id, Semaphore& s)
	: id_(id),
	  sem_(s)
	{}
	
	void run() {
		while(1) {
			cerr << "P(" << id_ << ") going to signal..." << endl;
			sem_.signal();
			sleep(1);
		}
	}
};

class C: public Thread {
	int id_;
	Semaphore& sem_;
public:
	C(int id, Semaphore& s)
	: id_(id),
	  sem_(s)
	{}
	
	void run() {
		while(1) {
			sem_.wait();
			cerr << "C(" << id_ << ") awake..." << endl;
			sleep(1);
		}
	}	
};

static const int PRODUCERS_COUNT=2;
static const int CONSUMERS_COUNT=20;


int main() {
	Semaphore sem(0);

	vector<P*> producers;
	vector<C*> consumers;
	
	for(int i=0;i<PRODUCERS_COUNT;i++) {
		producers.push_back(new P(i,sem));
	}
	for(int i=0;i<CONSUMERS_COUNT;i++) {
		consumers.push_back(new C(i,sem));
	}

	for(vector<C*>::iterator it=consumers.begin();
				it!=consumers.end();++it) {
		(*it)->start();
	}
	for(vector<P*>::iterator it=producers.begin();
				it!=producers.end();++it) {
		(*it)->start();
	}

	sleep(20);
	
	return 0;
};



